from django.forms import fields
from prettyforms.forms.widgets import (
        TextInput,
        Textarea,
        TimeInput,
        NumberInput,
        DateInput,
        DateTimeInput,
        EmailInput,
        ClearableFileInput,
        URLInput,
        CheckboxInput,
        Select,
        SelectMultiple,
)

__all__ = (
    "Field",
    "CharField",
    "TextField",
    "IntegerField",
    "PositiveIntegerField",
    "FloatField",
    "DecimalField",
    "DateField",
    "TimeField",
    "DateTimeField",
    "DurationField",
    "RegexField",
    "EmailField",
    "FileField",
    "ImageField",
    "URLField",
    "BooleanField",
    "NullBooleanField",
    "ChoiceField",
    "TypedChoiceField",
    "MultipleChoiceField",
    "TypedMultipleChoiceField",
    "ComboField",
    "MultiValueField",
    "FilePathField",
    "SplitDateTimeField",
    "GenericIPAddressField",
    "SlugField",
    "UUIDField",
    "JSONField",
)


class Field(fields.Field):
    widget = TextInput


class CharField(fields.CharField):
    widget = TextInput


class TextField(fields.CharField):
    widget = Textarea


class IntegerField(fields.IntegerField):
    widget = NumberInput


class PositiveIntegerField(fields.IntegerField):
    widget = NumberInput


class FloatField(fields.FloatField):
    widget = NumberInput


class DecimalField(fields.DecimalField):
    widget = NumberInput


class DateField(fields.DateField):
    widget = DateInput


class TimeField(fields.TimeField):
    widget = TimeInput


class DateTimeField(fields.DateTimeField):
    widget = DateTimeInput


class DurationField(fields.DurationField):
    widget = TextInput


class RegexField(fields.RegexField):
    widget = TextInput


class EmailField(fields.EmailField):
    widget = EmailInput


class FileField(fields.FileField):
    widget = ClearableFileInput


class ImageField(fields.ImageField):
    widget = ClearableFileInput


class URLField(CharField):
    widget = URLInput


class BooleanField(Field):
    widget = CheckboxInput


class NullBooleanField(BooleanField):
    widget = Select


class ChoiceField(fields.ChoiceField):
    widget = Select


class TypedChoiceField(fields.TypedChoiceField):
    widget = Select


class MultipleChoiceField(fields.MultipleChoiceField):
    widget = SelectMultiple


class TypedMultipleChoiceField(fields.TypedMultipleChoiceField):
    widget = SelectMultiple


class ComboField(fields.ComboField):
    widget = TextInput


class MultiValueField(fields.MultiValueField):
    widget = TextInput


class FilePathField(fields.FilePathField):
    widget = Select


class SplitDateTimeField(fields.SplitDateTimeField):
    widget = TextInput


class GenericIPAddressField(fields.GenericIPAddressField):
    widget = TextInput


class SlugField(fields.SlugField):
    widget = TextInput


class UUIDField(fields.UUIDField):
    widget = TextInput


class JSONField(fields.JSONField):
    widget = TextInput
